


    GLIB 2.1                                                  02.09.92



    ABOUT

    GLIB is a GRASP file librarian. It can extract files from a GRASP
    archive, add files, delete, and can be used to create archives
    that are in an Amiga friendly format. This program requires KS2.0
    to run.

    GLIB is one of the four programs in the GL 2.1 distribution. The
    others are the player GL, the .PIC/.CLP converter PIC2HL, and the
    font extracter GLFONT.

    GLIB is Copyright  1992 by John Bickers.


    USAGE

    GLIB requires the iff.library and the pattern.library. The
    xpkmaster.library may also be required for some existing Amiga
    files, and is strongly recommended in any case.

    The interface to this program is meant to be like an archiver's,
    so it has a format like:

        "glib <switches> <command> <archive name> <file list>"

    Typing "glib ?" will display a summary of the switches and commands
    available. This output looks like:

> USAGE: glib [-switches] [command] {GL file} [filelist]
>    switches: -hnum     Allow for num header records.
>              -iname    Use name as input file prefix.
>              -oname    Use name as output file prefix.
>              -p        Create a PClone archive (use with 'a' command).
>              -tname    Use name as temp directory prefix.
>              -xmethod  Use method for xpk compression.
>    command:  a[!]      Add [overwrite].
>              d         Delete.
>              l,v       List contents.
>              e,x       Extract.
>    filelist: a list of filenames. A name preceded by an '@' is assumed to
>              contain a list of files itself.


    SWITCHES

    -hnum   A buffer is allocated with one entry for each file that
            can be in a GL. The default size is 128. If you have a GL
            with more than 128 files in it, use this switch to
            increase the buffer size.

    -iname  This option affects the 'a' command. When a file is being
            added, it's name is checked for ':' and '/' characters. If
            there are none, then any prefix specified with the -i
            switch is prepended to the filename, with a '/' if
            necessary.

            For example, if you wanted to add all the .PIC and .CLP
            files in gfx:pictures/1 to the GL file ram:test.GL, you
            could type:

            3> glib -igfx:pictures/1 a ram:test #?.PIC #?.CLP

    -oname  This option affects the 'e' and 'x' commands. All
            extracted files will be saved into the directory specified
            by "name".

            For example, to extract all the .PIC files in ram:test.GL
            to ram:, you could type:

            3> glib -oram: x ram:test.GL #?.PIC

    -p      When used with the "a" command to create a new archive,
            this option creates a PClone format file. A PClone file
            does not have the Amiga ID in the first 4 bytes, and has
            numbers stored in Intel rather than Motorola order.

    -tname  When adding or extracting files, a temporary copy of the
            GL file is made. This switch lets you indicate where you
            want this to happen. The default temporary directory is
            "t:".

            You can save yourself a final copy from the temp file to
            the target archive name if you set this to be on the same
            volume that the target archive name is on.

    -xmethod
            Define the xpk compression method to use. Decompression
            automatically knows which method to use, but when adding
            files you can choose a method using this switch. If you
            don't use this switch, no compression is performed.

            Because it has a good compression ratio and a fast
            decompression speed, NUKE is probably the best choice for
            archives that you distribute.


    COMMANDS

    a[!]    The add command, with an optional "override" parameter.
            The files listed in the arguments are added to the
            archive. Any path prefix is removed from the filename
            when it is stored.

            If a file already exists in the archive, it will be
            skipped, unless you add the ! character to the command.
            For example, if you want to overwrite the file anim.txt
            in anim.GL, you can type:

            3> glib a! anim.GL anim.txt

            The new files are added to the archive header, then the
            archive is written out again. If all is successful, the
            old archive will be deleted (if there was one) and the new
            archive will take its place.

            If this is an Amiga archive, ILBM files being added will
            be converted to a raw form then compressed using the xpk
            libraries.

    d       The delete command. The filenames on the command line will
            be deleted from the archive.

            Matching filenames are removed from the archive header,
            and the archive is written out. If all is successful, the
            old archive will be deleted and the new archive will take
            its place.

    l,v     The list command. This lists the names and positions of
            the files in the archive.

    e,x     The extract command. The filenames on the command line
            will be extracted. If you used the -o switch, they will be
            saved to the directory you specified there. Otherwise they
            are saved to the current directory.

            If this is an Amiga archive, raw picture data will be
            saved out as IFF ILBMs. The w (width) field in the BMHD
            chunk of the file will be the same as the width used by
            the player. DPaint will use this width if you load the
            picture as a brush, but will NOT use it if you load the
            picture normally. Instead, it uses a width that divides
            evenly by 16. Mostra does this too.


    FILE LIST

    Arguments following the command and the archive name that do not
    start with a '-' character are treated as filenames. Wildcard
    expansion is performed for all commands.

    When a filename starts with '@', it is treated as a special case.
    The file is opened, and each line in the file is treated as a
    filename. The process is not recursive - if a filename WITHIN an
    @ file starts with a '@', it is not treated especially. Within
    the file, leading blanks are removed, and blank lines and lines
    starting with '#' are ignored.

    @ can be used to read filenames from the console, by using @* as
    an argument. For example:

    3> glib a ram:test.GL @*

    Hit Ctrl-\ to terminate the input. Note that this does NOT work
    at the end of a pipe.


    CREDITS

    GLIB is written by John Bickers using SAS C 5.10a.

    GRASP is a product of Microtex Industries, Inc. It's a sort of
    slideshow animation program on PClones.

    Christian A. Weber's iff.library is used for loading and saving
    ILBM files.

    Pattern matching is done through pattern.library, which is
    Copyright (c) Angela Schmidt.

    The xpkmaster.library and sublibraries are the work of U. Dominik
    Mueller and crew. The BLZW method, which I first saw in the form
    of compress.library, is the reason I thought about using a
    library to do compression.


    DISTRIBUTION

    GLIB is Copyright  1992 by John Bickers.

    Distribution is via normal channels. That is, distribute it for
    free, or for Fred Fish like costs, but not more. And remember to
    include the documentation.


    CONTACT INFO

    If you have suggestions or problems, or want to move data, I can
    be reached at:

        John Bickers
        214 Rata St
        Naenae 6301
        New Zealand

    Or: jbickers@templar.actrix.gen.nz


    DISCLAIMER

    It works on my machine.
