


    PIC2HL 1.2                                                01.09.92



    ABOUT

    PIC2HL is a HamLab filter for GRASP .PIC and .CLP files, types C,
    J, L and M.

    These .PIC and .CLP files can be extracted from MS-DOS GRASP (aka
    GL) files using my GLIB program, or something similar.

    PIC2HL can also be used to provide input data for the Wasp image
    conversion program.


    INSTALLING

    Add the following line to your HamLab configuration file:

    Format "\064\022" "pic2hl"  # GRASP .PIC or .CLP: [CJLM]

    And copy the PIC2HL binary to your HamLab filters directory.


    OPERATIONAL NOTES/PROBLEMS

    *   Some pictures, usually those ending with .CLP, do not contain
        a color palette. GRASP animations normally contain a dummy
        picture which is used to set the palette for these .CLP
        files.

        In order to provide a color map for these files, PIC2HL
        writes out a file called "t:picpal" whenever it processes a
        picture that has a palette. Then, if a picture does not have
        a palette, this file is loaded and used.

    *   In some cases, the t:picpal file is not enough. A picture
        will have a palette that it is not supposed to have. By
        renaming a correct picpal file to "t:picpal!", you can
        override the palette within the picture. In this case, a
        t:picpal file will not be created afterwards.

        The format of these files is just a raw dump of RGB triples.
        All display mode-specific processing is done _before_ the
        picpal file is written out.

    *   .PIC and .CLP pictures start with the bottom of the picture
        at the start of the file. So PIC2HL must buffer the entire
        picture before sending it out to HamLab.

    *   I don't have many type J or M pictures, and I'm not sure how
        to treat palette type 2s, so the EGA pictures may come out
        wrong. Let me know.

        A palette type 2 is a "pcjr or non ECD 16 color registers
        (0-15)".

    *   A small number of pictures I've come across do not have a
        valid video mode byte. In some cases, I have been able to
        convert these pictures successfully by placing an 'L' (for
        GLs that use 'L' pictures) in byte 12, counting from zero.

    *   To use PIC2HL with Wasp, use the command line option "-wasp".
        For example, to convert the file goofy.pic to a LORES ILBM
        picture, you would use:

            3> pic2hl -wasp < goofy.pic > ram:temp.raw
            3> waspa -lores -zap ram:temp.raw goofy.pic

        The ram:temp.raw file will be in Wasp's own SRGR format. I
        used the source for Wasp 1.23 to determine this format.


    CREDITS

    Written by John Bickers using SAS C 5.10a.

    Sample data provided by Scott Corley.

    HamLab is a program by Ed Hanway that takes a picture file and
    passes it through a filter to get 24-bit data. HamLab then
    processes the 24-bit file to produce a HAM picture.

    EGA palette information is sourced from XGRASP, an X-Windows GL
    player by Patrick J. Naughton.

    Some type information was also sourced from the 1988 document
    "PCPAINT/Pictor Page Format Description", by John Bridges.

    GRASP is a product of Microtex Industries, Inc. It's a sort of
    slideshow animation program.

    Wasp is an image conversion program written by Steven Reiz.


    DISTRIBUTION

    PIC2HL is Copyright  1992 by John Bickers.

    This program may be distributed freely, as long as no more than
    Fred Fish type costs are asked for it, with the sole exception of
    Ed Hanway, who may distribute this program with no restriction.


    CONTACT INFO

    If you have suggestions or problems, I can be reached at:

        John Bickers
        214 Rata St
        Naenae 6301
        New Zealand

    Or: jbickers@templar.actrix.gen.nz
