


    MAKEDL 1.0                                                26.07.94



    ABOUT

    This is a CLI-based DL animation creator for machines with KS 2.0
    or better. It creates version 2 DL files based on a script that
    you give it, much like MKANIM and similar programs.

    DL files are a kind of animation once found only on PCs. The
    animations are either 320x200, 160x100, or 80x50, in 256 colors.
    The colors are 18 bits each, 6 per gun.

    MAKEDL is Copyright  1994 by John Bickers.


    REQUIREMENTS

    MAKEDL requires a machine with at least KS2.0, and Christian
    Weber's IFF library. The IFF library can be found on the Aminet
    sites, and has to be no older than version 22.


    PARAMETERS

    The command template is:

    DL/A,SCRIPT/A,24BIT/S

    The DL option is the name of the DL file you want to create, and
    must be present.

    The SCRIPT option is also required, and is the name of the script
    file that will define what goes into the animation. The script
    file format is described below.

    The 24BIT option lets you force the palette in the DL file to be
    a 24-bit palette. The format really wants an 18-bit palette, but
    the TAPDL player on the Amiga is capable of handling both. Be
    warned that an animation with a 24-bit palette will NOT play back
    correctly on a PC, and I don't think that the difference in color
    quality is really worth the hassle.


    SCRIPT FILE FORMAT

    A script file is a simple text file containing a number of lines
    of the form "<item> = <value>". The items are...

    title       A title for the animation. This has a maximum length
                of 20 characters.

    author      The author of the animation. Put your name here. This
                field also has a maximum length of 20 characters.

    model       This is a number, either 0, 1 or 2. These represent
                the dimensions of the animation, either 320x200,
                160x100, or 80x50 respectively.

    frame       The name of the IFF file containing a frame of the
                animation. There can be more than one frame field, and
                they should appear in the same order that you will
                index them in the command field. The dimensions of
                each frame should match the dimensions you select with
                the model field, but this isn't totally necessary. The
                IFF library tries to clip or pad bitmaps as required.

    command     A command sequence for controlling the playback of the
                animation. This is a list of values seperated by
                commas, where a value can be one of...

                1.  A frame index, counting from 0. The frame you
                    select will be the frame displayed at this point,
                    with a default delay of 5/100ths of a second
                    between frames.

                2.  A loop indicator, L<N>, where N is the number of
                    times that the loop should be executed. Note that
                    the entire animation will loop ad infinitum, so an
                    L<N> is only required for sub-loops.

                3.  An end-of-loop indicator, E.

                4.  A pause indicator, P<N>, where the pause will be
                    N/100ths of a second long.

    As a test, which I can't distribute because of the nature of the
    picture involved, I created 6 160x100/8 brushes that scrolled down
    the centre of a picture (debanimation). The script file to create
    a DL anim from these brushes looked like...

                title = TEST ANIM
                author = John Bickers
                model = 1
                frame = suelin1.iff
                frame = suelin2.iff
                frame = suelin3.iff
                frame = suelin4.iff
                frame = suelin5.iff
                frame = suelin6.iff
                command = 0,1,2,3,4,5,4,3,2,1


    CREDITS

    MAKEDL is written by John Bickers using SAS C 6.51.

    The DL file format and PC programs were created by Davide Tome'
    and Luca De Gregorio. The format of a DL file was obtained by
    looking at sample files, and running Davide and Luca's DL-VIEW.EXE
    under Microsoft's CodeView debugger.

    Thanks to Christian Geisert for a variety of sample files.

    Christian A. Weber's iff.library is used for loading ILBM files.


    DISTRIBUTION

    MAKEDL is Copyright  1994 by John Bickers.

    Distribution is via normal channels. That is, distribute it for
    free, or for Fred Fish like costs, but not more. And remember to
    include the documentation.

    If you use this program, I'd be keenly interested in a copy of the
    animations that you create. I'm also interested in any suggestions
    that you may have for making this program easier to use.


    CONTACT INFO

    I can be reached at:

        John Bickers
        214 Rata St
        Naenae
        New Zealand

    Or: jbickers@templar.actrix.gen.nz


    DISCLAIMER

    It works on my machine.


    HISTORY

    94.07.25    Created 1.0.
